package com.acm.sample;

import com.alibaba.edas.acm.ConfigService;
import com.alibaba.edas.acm.exception.ConfigException;
import com.alibaba.edas.acm.listener.ConfigChangeListener;

import java.io.IOException;
import java.io.StringReader;
import java.util.Properties;

public class App {

    private static Properties appCfg = new Properties();

    public static void initAndWatchConfig() {

        final String dataId = "com.acm.myapp.app.cfg";
        final String group = "myapp";
        final long timeoutInMills = 3000;

        // ӿ̨ռпӦֵ
        Properties properties = new Properties();
        properties.put("endpoint", "$endpoint");
        properties.put("namespace", "$namespace");
        // ͨ ECS ʵ RAM ɫ ACM
        // properties.put("ramRoleName", "$ramRoleName");
        properties.put("accessKey", "$accessKey");
        properties.put("secretKey", "$secretKey");
        // ǰȫãҪԶ
        // properties.put("openKMSFilter", true);
        // properties.put("regionId", "$regionId");

        ConfigService.init(properties);

        // ֻһγֱgetȡֵ
        try {
            String configInfo = ConfigService.getConfig(dataId, group, timeoutInMills);
            appCfg.load(new StringReader(configInfo));
        } catch (ConfigException e1) {
            e1.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        // ñ仯ȡֵ
        ConfigService.addListener(dataId, group, new ConfigChangeListener() {
            public void receiveConfigInfo(String configInfo) {
                try {
                    appCfg.load(new StringReader(configInfo));
                } catch (Exception e) {
                    // process exception
                }

                refreshApp();
            }
        });
    }

    public static void refreshApp() {
        System.out.println("current thread pool size: " + appCfg.getProperty("threadPoolSize"));
        System.out.println("current log level: " + appCfg.getProperty("logLevel"));
        System.out.println("");
    }

    public static void main(String[] args) {

        initAndWatchConfig();

        // ̲߳˳Ϊػ̣߳߳˳ػ߳̾ͻ˳ ʽ
        while (true) {
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e) {
            }
        }

    }
}
